Bug 589917 - bad dwarf cfi data in module-init-tools binary
Summary: bad dwarf cfi data in module-init-tools binary
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: module-init-tools
Version: 6.0
Hardware: All
OS: Linux
low
medium
Target Milestone: rc
: ---
Assignee: Jon Masters
QA Contact: Martin Cermak
URL:
Whiteboard:
Depends On:
Blocks: 503551
TreeView+ depends on / blocked
 
Reported: 2010-05-07 10:01 UTC by Mark Wielaard
Modified: 2010-11-10 21:10 UTC (History)
3 users (show)

Fixed In Version: module-init-tools-3.9-10.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-11-10 21:10:50 UTC
Target Upstream Version:


Attachments (Terms of Use)
python script to check for bad cfi in a binary (1.76 KB, text/plain)
2010-05-07 10:24 UTC, Mark Wielaard
no flags Details

Description Mark Wielaard 2010-05-07 10:01:02 UTC
Description of problem:

An old version of gcc generated bad dwarf cfi expressions. This would not impact the functioning of the package itself, but might make debugging the binary with gdb, or tracing with systemtap less practical. This isn't a very high priority. But if the package can be rebuild with a current toolchain, gcc-4.4.3-19.el6 or later, that would solve this issue. Background information: http://gcc.gnu.org/ml/gcc-patches/2010-04/msg01422.html This only affects a very small number of packages (and only the i686 binaries).

Version-Release number of selected component (if applicable):

module-init-tools-3.9-5.el6.i686 (/sbin/depmod, /sbin/insmod.static)

The attached check_cfi.py script (thanks to Petr Machata) can be used to check the output of readelf --debug-dump=frames to see whether the faulty dwarf cfi expressions are present in the binary. There should be no output, currently the output is:

readelf --debug-dump=frames /sbin/depmod | tail -n +3 | python check_cfi.py
['00000000', '00000014', '00000000', 'CIE']
   DW_CFA_def_cfa: r4 (esp) ofs 4
   DW_CFA_offset: r8 (eip) at cfa-4
   DW_CFA_nop
   DW_CFA_nop
['000004c4', '00000044', '000004c8', 'FDE', 'cie=00000000', 'pc=0804b460..0804c079']
   DW_CFA_advance_loc: 4 to 0804b464
>  DW_CFA_def_cfa: r1 (ecx) ofs 0
   DW_CFA_advance_loc: 9 to 0804b46d
   DW_CFA_expression: r5 (ebp) (DW_OP_breg5: 0)
   DW_CFA_advance_loc: 4 to 0804b471
>  DW_CFA_def_cfa_expression (DW_OP_breg5: -16; DW_OP_deref)
   DW_CFA_advance_loc: 9 to 0804b47a
   DW_CFA_expression: r3 (ebx) (DW_OP_breg5: -12)
   DW_CFA_expression: r6 (esi) (DW_OP_breg5: -8)
   DW_CFA_expression: r7 (edi) (DW_OP_breg5: -4)
   DW_CFA_advance_loc2: 2084 to 0804bc9e
   DW_CFA_remember_state
>  DW_CFA_def_cfa_register: r1 (ecx)
   DW_CFA_advance_loc: 1 to 0804bc9f
   DW_CFA_restore: r3 (ebx)
   DW_CFA_advance_loc: 1 to 0804bca0
   DW_CFA_restore: r6 (esi)
   DW_CFA_advance_loc: 1 to 0804bca1
   DW_CFA_restore: r7 (edi)
   DW_CFA_advance_loc: 1 to 0804bca2
   DW_CFA_restore: r5 (ebp)
   DW_CFA_advance_loc: 3 to 0804bca5
   DW_CFA_def_cfa: r4 (esp) ofs 4
   DW_CFA_advance_loc: 3 to 0804bca8
   DW_CFA_restore_state
   DW_CFA_nop
   DW_CFA_nop
   DW_CFA_nop
error in instr #16, DW_CFA_def_cfa_register

readelf --debug-dump=frames /sbin/insmod.static | tail -n +3 | python check_cfi.py
['00000000', '00000014', '00000000', 'CIE']
   DW_CFA_def_cfa: r4 (esp) ofs 4
   DW_CFA_offset: r8 (eip) at cfa-4
   DW_CFA_nop
   DW_CFA_nop
['00006460', '00000040', '00006464', 'FDE', 'cie=00000000', 'pc=08075460..08079eb7']
   DW_CFA_advance_loc: 4 to 08075464
>  DW_CFA_def_cfa: r1 (ecx) ofs 0
   DW_CFA_advance_loc: 16 to 08075474
   DW_CFA_expression: r5 (ebp) (DW_OP_breg5: 0)
   DW_CFA_advance_loc: 13 to 08075481
>  DW_CFA_def_cfa_expression (DW_OP_breg5: -16; DW_OP_deref)
   DW_CFA_advance_loc: 26 to 0807549b
   DW_CFA_expression: r7 (edi) (DW_OP_breg5: -4)
   DW_CFA_expression: r6 (esi) (DW_OP_breg5: -8)
   DW_CFA_expression: r3 (ebx) (DW_OP_breg5: -12)
   DW_CFA_advance_loc2: 390 to 08075621
   DW_CFA_remember_state
>  DW_CFA_def_cfa_register: r1 (ecx)
   DW_CFA_advance_loc: 13 to 0807562e
   DW_CFA_restore: r7 (edi)
   DW_CFA_restore: r6 (esi)
   DW_CFA_restore: r3 (ebx)
   DW_CFA_advance_loc: 1 to 0807562f
   DW_CFA_restore: r5 (ebp)
   DW_CFA_advance_loc: 3 to 08075632
   DW_CFA_def_cfa: r4 (esp) ofs 4
   DW_CFA_advance_loc: 6 to 08075638
   DW_CFA_restore_state
   DW_CFA_nop
error in instr #16, DW_CFA_def_cfa_register

[...]

Comment 1 Mark Wielaard 2010-05-07 10:24:25 UTC
Created attachment 412291 [details]
python script to check for bad cfi in a binary

Comment 3 RHEL Program Management 2010-05-07 11:31:18 UTC
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux major release.  Product Management has requested further
review of this request by Red Hat Engineering, for potential inclusion in a Red
Hat Enterprise Linux Major release.  This request is not yet committed for
inclusion.

Comment 4 Jon Masters 2010-05-18 18:03:01 UTC
I do plan to rebuild the package prior to beta2 anyway, so I am assuming that will be sufficient, given the toolchain fixes cited.

Comment 5 Mark Wielaard 2010-05-18 18:26:21 UTC
(In reply to comment #4)
> I do plan to rebuild the package prior to beta2 anyway, so I am assuming that
> will be sufficient, given the toolchain fixes cited.    

Yes, that would do it. Thanks.

Comment 6 Jon Masters 2010-05-18 23:01:07 UTC
No problem!

Comment 14 Martin Cermak 2010-09-24 08:26:03 UTC
=> VERIFIED

Comment 15 Jon Masters 2010-09-30 04:40:48 UTC
Thanks

Comment 16 releng-rhel@redhat.com 2010-11-10 21:10:50 UTC
Red Hat Enterprise Linux 6.0 is now available and should resolve
the problem described in this bug report. This report is therefore being closed
with a resolution of CURRENTRELEASE. You may reopen this bug report if the
solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.